.386
.387

;---------------------------------------;
;    *ROUNDING UP AND DOWN ROUTINES*    ;
;    !Numeric processor is required!    ;
;                                       ;
;     (c) 1999 by Alexei A. Frounze     ;
; Homepage: http://www.chat.ru/~alexfru ;
;        E-mail: alexfru@chat.ru        ;
;---------------------------------------;


cFloor  EQU     173Fh           ;Rounding to the negative infinity direction
cCeil   EQU     1B3Fh           ;Rounding to the positive infinity direction
cTrunc  EQU     1F3Fh           ;Rounding to the zero direction

PUBLIC  FLOOR, CEIL

CODE    SEGMENT BYTE PUBLIC USE16
        ASSUME CS:CODE,DS:CODE

FLOOR   PROC PASCAL NEAR        X:QWord
LOCAL SW:Word, LW:Word, Res:DWord

        FSTCW   SW
        Mov     LW, cFloor
        FLDCW   LW
        FLD     QWord Ptr X
        FRndInt
        FWait
        FLDCW   SW
        FISTP   Res
        Mov     AX, Word Ptr Res
        Mov     DX, Word Ptr Res+2

        Ret
FLOOR   ENDP

CEIL    PROC PASCAL NEAR        X:QWord
LOCAL SW:Word, LW:Word, Res:DWord

        FSTCW   SW
        Mov     LW, cCeil
        FLDCW   LW
        FLD     QWord Ptr X
        FRndInt
        FWait
        FLDCW   SW
        FISTP   Res
        Mov     AX, Word Ptr Res
        Mov     DX, Word Ptr Res+2

        Ret
CEIL    ENDP

CODE    ENDS

END
